function [dist,prev] = shortestpaths(E, s, k);
    n = size(E,1);
    infinity = 1e10;
    dist = infinity*ones(n,1);
    prev = zeros(n,1);
    dist(s) = 0;
    for t = 1:k
        for v = 1:n
            for j = 1:size(E{v},1)
                u = E{v}(j,1);
                w = E{v}(j,2);
                if dist(v)+w < dist(u)
                    dist(u) = dist(v)+w;
                    prev(u) = v;
                end                
            end
        end
    end
end
